REXML::XMLDecl#encodingがStringではなくEncodingを返すようにする
Priority: Normal   

Assignee: kou (Kouhei Sutou)   

Target version: 2.0.0   

Description

経緯は #3990 の後ろの方の流れを参照。

1.9.3がリリースされてからやる。

Related issues:

Related to Ruby - Bug #3990: tests of rexml/rss reports many errors and failu... Closed 10/27/2010

Associated revisions

Revision af83fcfe4de5d0497e78789efdfb7e7daf251805 - 10/28/2012 06:43 AM - Sutou Kouhei 

lib/rexml/document.rb (REXML::Document#write): Add :encoding option

to support custom XML encoding.

[Feature #4872] (work in progress)

test/rexml/test_document.rb: Add tests for the above change.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@37355 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision af83fcfe - 10/28/2012 06:43 AM - Sutou Kouhei 

lib/rexml/document.rb (REXML::Document#write): Add :encoding option

to support custom XML encoding.

[Feature #4872] (work in progress)

test/rexml/test_document.rb: Add tests for the above change.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@37355 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 3f817764e24eb05aceef884e213d4a7043c292fa - 11/03/2012 03:53 AM - Sutou Kouhei 

lib/rexml/document.rb (REXML::Document#write): Document encoding

option. Now different encoding between XML file's encoding and

XML declaration's encodiong is support.

[Feature #4872] (work in progress)

lib/rexml/xmldecl.rb (REXML::XMLDecl#write): Always use XMLDecl's

encoding.

test/rexml/test_document.rb: Update tests for the above change.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@37440 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 3f817764 - 11/03/2012 03:53 AM - Sutou Kouhei 

lib/rexml/document.rb (REXML::Document#write): Document encoding

option. Now different encoding between XML file's encoding and

XML declaration's encodiong is support.

[Feature #4872] (work in progress)

lib/rexml/xmldecl.rb (REXML::XMLDecl#write): Always use XMLDecl's

encoding.

test/rexml/test_document.rb: Update tests for the above change.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@37440 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 06/11/2011 11:15 PM - kou (Kouhei Sutou)

（本文中で #3990 にリンクをはるにはどうしたらよいのでしょうか。。。）
#2 - 07/19/2011 06:41 PM - kou (Kouhei Sutou)

=begin

成瀬さんと話して（やるなら）以下のようにすることにした。

REXML::XMLDecl#encodingはEncodingを返すようにする。

REXML::XMLDecl#writeで使うXMLエンコーディングは引数で指定できるようにする。（指定されない場合はREXL::XMLDecl#encodingを使ってXMLエンコーディングを決める。）

=end

#3 - 03/18/2012 06:46 PM - shyouhei (Shyouhei Urabe)

- Status changed from Open to Assigned

#4 - 10/28/2012 03:43 PM - kou (Kouhei Sutou)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r37355.

Kouhei, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

lib/rexml/document.rb (REXML::Document#write): Add :encoding option

to support custom XML encoding.

[Feature #4872] (work in progress)

test/rexml/test_document.rb: Add tests for the above change.

#5 - 11/03/2012 02:11 PM - kou (Kouhei Sutou)

kou (Kouhei Sutou) wrote:

REXML::XMLDecl#encodingはEncodingを返すようにする。

 これはやらないことにしました。

これをやりたかったもともとの理由は、ユーザーとしてエンコーディング情報を正規化した状態で扱いたかった（UTF-8かutf-8かとか気にしたくない）からでした。が、よく見てみたら、XMLDecl#encodingはupcaseして

正規化していました。（utf-8を気にせずに常にUTF-8かで確認できた。）なので、やる理由がなくなりました。

あと、↓の通り、XML宣言のencodingとXML文書のエンコーディングを結び付けないことにした（結び付けないこともできるようにした）のでXML文書のエンコーディングをXMLDecl#encoding（これはXML宣言の

encoding）で返すのがおかしいなぁと思うようになりました。なので、やめました。XML文書のエンコーディングをだれが持つかという話は↓で。

REXML::XMLDecl#writeで使うXMLエンコーディングは引数で指定できるようにする。（指定されない場合はREXL::XMLDecl#encodingを使ってXMLエンコーディングを決める。）

 これはREXML::XMLdecl#writeじゃなくてREXML::Document#writeで出力エンコーディングを指定できるようにしました。

XML宣言のencodingとXML文書のエンコーディングを変えたい時（例えば、XML宣言のencodingはShift_JISでXML文書のエンコーディングはWindows-31Jにしたい時）はこうします。

document.xml_decl.encoding = "Shift_JIS"

document.write(:encoding => "Windows-31J")

こうした理由はXML文書を生成するときはREXML::XMLDecl#writeではなくREXML::Document#writeを使うので、REXML::XMLDecl#writeでカスタマイズできても使いづらいからです。

XML宣言のencodingとXML文書のエンコーディングを別々に指定したい、というのが実現したいことです。それを、REXML::Docuemnt#writeでやるならXML宣言のencodingではなくXML文書のエンコーデ

ィングを指定するのが自然なので（DocumentはXML文書のことだから）、XML宣言のencodingではなくXML文書のエンコーディングを出力時に変更できるようにしました。

#6 - 11/04/2012 12:10 AM - naruse (Yui NARUSE)

kou (Kouhei Sutou) wrote:

kou (Kouhei Sutou) wrote:

REXML::XMLDecl#encodingはEncodingを返すようにする。

 これはやらないことにしました。

これをやりたかったもともとの理由は、ユーザーとしてエンコーディング情報を正規化した状態で扱いたかった（UTF-8かutf-8かとか気にしたくない）からでした。が、よく見てみたら、XMLDecl#encodingはupca

seして正規化していました。（utf-8を気にせずに常にUTF-8かで確認できた。）なので、やる理由がなくなりました。

あと、↓の通り、XML宣言のencodingとXML文書のエンコーディングを結び付けないことにした（結び付けないこともできるようにした）のでXML文書のエンコーディングをXMLDecl#encoding（これはXM

L宣言のencoding）で返すのがおかしいなぁと思うようになりました。なので、やめました。XML文書のエンコーディングをだれが持つかという話は↓で。

REXML::XMLDecl#writeで使うXMLエンコーディングは引数で指定できるようにする。（指定されない場合はREXL::XMLDecl#encodingを使ってXMLエンコーディングを決める。）
 これはREXML::XMLdecl#writeじゃなくてREXML::Document#writeで出力エンコーディングを指定できるようにしました。

XML宣言のencodingとXML文書のエンコーディングを変えたい時（例えば、XML宣言のencodingはShift_JISでXML文書のエンコーディングはWindows-31Jにしたい時）はこうします。

document.xml_decl.encoding = "Shift_JIS"

document.write(:encoding => "Windows-31J")

こうした理由はXML文書を生成するときはREXML::XMLDecl#writeではなくREXML::Document#writeを使うので、REXML::XMLDecl#writeでカスタマイズできても使いづらいからです。

XML宣言のencodingとXML文書のエンコーディングを別々に指定したい、というのが実現したいことです。それを、REXML::Docuemnt#writeでやるならXML宣言のencodingではなくXML文書のエ

ンコーディングを指定するのが自然なので（DocumentはXML文書のことだから）、XML宣言のencodingではなくXML文書のエンコーディングを出力時に変更できるようにしました。

 なるほど、確かにその方がよいと思います。
